Imports System.Drawing.Printing

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents PrintPreviewDialog1 As System.Windows.Forms.PrintPreviewDialog
    Friend WithEvents btnPreview As System.Windows.Forms.Button
    Friend WithEvents btnPrint As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(Form1))
        Me.PrintPreviewDialog1 = New System.Windows.Forms.PrintPreviewDialog
        Me.btnPreview = New System.Windows.Forms.Button
        Me.btnPrint = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'PrintPreviewDialog1
        '
        Me.PrintPreviewDialog1.AutoScrollMargin = New System.Drawing.Size(0, 0)
        Me.PrintPreviewDialog1.AutoScrollMinSize = New System.Drawing.Size(0, 0)
        Me.PrintPreviewDialog1.ClientSize = New System.Drawing.Size(400, 300)
        Me.PrintPreviewDialog1.Enabled = True
        Me.PrintPreviewDialog1.Icon = CType(resources.GetObject("PrintPreviewDialog1.Icon"), System.Drawing.Icon)
        Me.PrintPreviewDialog1.Location = New System.Drawing.Point(15, 16)
        Me.PrintPreviewDialog1.MinimumSize = New System.Drawing.Size(375, 250)
        Me.PrintPreviewDialog1.Name = "PrintPreviewDialog1"
        Me.PrintPreviewDialog1.TransparencyKey = System.Drawing.Color.Empty
        Me.PrintPreviewDialog1.Visible = False
        '
        'btnPreview
        '
        Me.btnPreview.Location = New System.Drawing.Point(16, 16)
        Me.btnPreview.Name = "btnPreview"
        Me.btnPreview.TabIndex = 0
        Me.btnPreview.Text = "Preview"
        '
        'btnPrint
        '
        Me.btnPrint.Location = New System.Drawing.Point(112, 16)
        Me.btnPrint.Name = "btnPrint"
        Me.btnPrint.TabIndex = 1
        Me.btnPrint.Text = "Print"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(200, 53)
        Me.Controls.Add(Me.btnPrint)
        Me.Controls.Add(Me.btnPreview)
        Me.Name = "Form1"
        Me.Text = "Form1"
        Me.ResumeLayout(False)

    End Sub

#End Region

    ' The PrintDocument object does the printing.
    Private WithEvents m_PrintDocument As PrintDocument
    Private m_PageNumber As Integer
    Private m_Font As Font

    ' Display a print preview.
    Private Sub btnPreview_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPreview.Click
        m_PrintDocument = New PrintDocument
        PrintPreviewDialog1.Document = m_PrintDocument
        Try
            PrintPreviewDialog1.ShowDialog()
        Catch ex As Exception
        End Try
    End Sub

    ' Print the document.
    Private Sub btnPrint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnPrint.Click
        m_PrintDocument = New PrintDocument
        Try
            m_PrintDocument.Print()
        Catch ex As Exception
        End Try
    End Sub

    ' Prepare to start printing. 
    ' Open files, build fonts, load resources, etc.
    Private Sub m_PrintDocument_BeginPrint(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintEventArgs) Handles m_PrintDocument.BeginPrint
        Dim font_family As New FontFamily("Comic Sans MS")
        m_Font = New Font(font_family, 120, FontStyle.Bold)

        m_PageNumber = 0
    End Sub

    ' Print a page.
    Private Sub m_PrintDocument_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles m_PrintDocument.PrintPage
        Dim margin_rect As New RectangleF(e.MarginBounds.Left, e.MarginBounds.Top, e.MarginBounds.Width, e.MarginBounds.Height)
        Dim string_format As New StringFormat(StringFormatFlags.NoWrap)
        string_format.Alignment = StringAlignment.Center
        string_format.LineAlignment = StringAlignment.Center

        m_PageNumber += 1

        ' See which page this is.
        Select Case m_PageNumber
            Case 1
                ' Draw an ellipse.
                e.Graphics.DrawEllipse( _
                    New Pen(Color.Black, 10), _
                    e.MarginBounds)
                e.Graphics.DrawString("One", m_Font, Brushes.Black, _
                    margin_rect, string_format)
            Case 2
                ' Draw a rectangle.
                e.Graphics.DrawRectangle( _
                    New Pen(Color.Black, 10), _
                    e.MarginBounds)
                e.Graphics.DrawString("Two", m_Font, Brushes.Black, _
                    margin_rect, string_format)
            Case 3
                ' Draw a diamond.
                With e.MarginBounds
                    Dim pts() As Point = { _
                        New Point(.Left, .Top + .Height / 2), _
                        New Point(.Left + .Width / 2, .Top), _
                        New Point(.Left + .Width, .Top + .Height / 2), _
                        New Point(.Left + .Width / 2, .Top + .Height) _
                    }
                    e.Graphics.DrawPolygon( _
                        New Pen(Color.Black, 10), _
                        pts)
                End With
                e.Graphics.DrawString("Three", m_Font, Brushes.Black, _
                    margin_rect, string_format)
        End Select

        ' Page 3 is the last page.
        e.HasMorePages = (m_PageNumber < 3)
    End Sub

    ' Clean up after printing. 
    ' Close files, free resources, etc.
    Private Sub m_PrintDocument_EndPrint(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintEventArgs) Handles m_PrintDocument.EndPrint
        m_PrintDocument = Nothing
        m_Font = Nothing
    End Sub
End Class
